package com.senter.support.openapi.demo.barcodescan;

import java.util.concurrent.atomic.AtomicBoolean;

import com.senter.support.openapi.StBarcodeScanner;

import android.os.Bundle;
import android.util.Log;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;
import android.app.Activity;

public class SdkBarcodeScanActivity extends Activity
{
	public static final String Tag="MainActivity";
	AtomicBoolean isScanning=new AtomicBoolean(false);
	@Override
	protected void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		//scan button on ui
		Button btnButton=(Button) findViewById(R.id.idMainActivity_btnScan);
		btnButton.setOnClickListener(new OnClickListener()
		{
			@Override
			public void onClick(View v)
			{//scan
				scan();
			}
		});
	}

	/**
	 * response to physical button
	 */
	@Override
	public boolean onKeyDown(	int keyCode, KeyEvent event)
	{
		switch (keyCode)
		{
			case 235://ST327
			case 212://ST307
			case 221://ST308 ST309
				scan();
				break;
			default:
				break;
		}
		return super.onKeyDown(keyCode, event);
	}

	/**
	 * trig a scan action,show the result on textview,which is at the top of activity. 
	 */
	private void scan()
	{
		final TextView tView=(TextView) findViewById(R.id.idMainActivity_tvScan);

		new Thread()
		{
			public void run()
			{
				if (isScanning.compareAndSet(false, true)==false)
				{//at the same time only one thread can be allowed to scan
					return;
				}
				
				try
				{
					StBarcodeScanner scanner=StBarcodeScanner.getInstance();
					if (scanner==null)
					{
						Log.e(Tag, "!!!!!!!!!!!!sdk is to old to work，please update sdk");
						return;
					}
					String rslt=scanner.scan();//scan ,if failed,null will be return
					
					final String show=(rslt!=null)?rslt:"failed";
					Log.e("barcodeDemo", "scan result:"+show);
					
					//update ui
					runOnUiThread(new Runnable()
					{
						@Override
						public void run()
						{
							tView.setText(show);
						}
					});
				}
				catch (InterruptedException e)
				{
					e.printStackTrace();
				}
				finally
				{
					isScanning.set(false);
				}
			};
		}.start();
	}
	
	
	
}






















